diff -ruN ../nakedmudv3.0/src/items/worn.c src/items/worn.c
--- ../nakedmudv3.0/src/items/worn.c	Fri Oct  7 14:15:55 2005
+++ src/items/worn.c	Sun Dec  4 20:03:07 2005
@@ -29,6 +29,7 @@
 #include "../object.h"
 #include "../inform.h"
 #include "../handler.h"
+#include "../hooks.h"
 
 #include "../olc2/olc.h"
 #include "iedit.h"
@@ -73,6 +74,15 @@
   return (entry ? entry->positions : "");
 }
 
+//
+// append information about where the item can be worn
+void append_worn_hook(BUFFER *desc, OBJ_DATA *obj, CHAR_DATA *ch) {
+  if(objIsType(obj, "worn")) {
+    bprintf(desc, "When worn, this item covers bodyparts: %s.", 
+	    wornGetPositions(obj));
+  }
+}
+
 
 
 //*****************************************************************************
@@ -163,13 +173,13 @@
 
   text_to_buffer(sock, "{wEditable item types:{g\r\n");
   ITERATE_LIST(key, type_i) {
-    send_to_socket(sock, "  %-14s%s",
-		   key, ((col != 0 && col % 3 == 0) ? "\r\n": "   "));
     col++;
+    send_to_socket(sock, "  %-14s%s",
+		   key, ((col != 0 && col % 4 == 0) ? "\r\n": "   "));
   }
   deleteListIterator(type_i);
   deleteListWith(types, free);
-  if(col % 3 != 0) text_to_buffer(sock, "\r\n");
+  if(col % 4 != 0) text_to_buffer(sock, "\r\n");
 }
 
 
@@ -293,6 +303,9 @@
   // set up the worn OLC too
   item_add_olc("worn", iedit_worn_menu, iedit_worn_chooser, iedit_worn_parser,
 	       worn_from_proto, worn_to_proto);
+
+  // attach our hooks to display worn info on look
+  hookAdd("append_obj_desc", append_worn_hook);
 
   // add our new python get/setters
   PyObj_addGetSetter("worn_type", PyObj_getworntype, PyObj_setworntype,
diff -ruN ../nakedmudv3.0/src/list.c src/list.c
--- ../nakedmudv3.0/src/list.c	Fri Oct  7 14:15:55 2005
+++ src/list.c	Sun Dec  4 20:03:07 2005
@@ -14,6 +14,7 @@
 //*****************************************************************************
 
 #include <stdlib.h>
+#include <stdarg.h>
 #include "list.h"
 
 #ifndef FALSE
@@ -435,6 +436,16 @@
 
   return newlist;
 }
+
+void listParse(LIST *L, int n, ...) {
+  int i;
+  va_list args;
+  va_start(args, n);
+  for(i = 0; i < n; i++)
+    *va_arg(args, void **) = listGet(L, i);
+  va_end(args);
+}
+
 
 
 //*****************************************************************************
diff -ruN ../nakedmudv3.0/src/list.h src/list.h
--- ../nakedmudv3.0/src/list.h	Fri Oct  7 14:15:55 2005
+++ src/list.h	Sun Dec  4 20:03:07 2005
@@ -148,6 +148,12 @@
 LIST *listCopyWith(LIST *L, void *func);
 
 
+//
+// Parses out the first n arguments of the list, and assigns them to the 
+// pointers supplied as arguments in the elipsis. Assumes n <= listSize(L)
+void listParse(LIST *L, int n, ...);
+
+
 
 //*****************************************************************************
 // list iterator function prototypes
diff -ruN ../nakedmudv3.0/src/log.c src/log.c
--- ../nakedmudv3.0/src/log.c	Fri Oct  7 14:15:55 2005
+++ src/log.c	Sun Dec  4 20:03:07 2005
@@ -132,19 +132,18 @@
       found = TRUE;
     // for each key, see if it exists in the string
     else {
-      int i, num_keys = 0;
-      char **keys = NULL;
-      keys = parse_keywords(keywords, &num_keys);
-      for(i = 0; i < num_keys; i++) {
+      LIST           *keys = parse_keywords(keywords);
+      LIST_ITERATOR *key_i = newListIterator(keys);
+      char            *key = NULL;
+
+      ITERATE_LIST(key, key_i) {
 	// found one
-	if(strstr(string, keys[i])) {
+	if(strstr(string, key)) {
 	  found = TRUE;
 	  break;
 	}
-      }
-      // free all of the keys
-      for(i = 0; i < num_keys; i++)
-	free(keys[i]);
+      } deleteListIterator(key_i);
+      deleteListWith(keys, free);
     }
 
     if(found) {
diff -ruN ../nakedmudv3.0/src/map.c src/map.c
--- ../nakedmudv3.0/src/map.c	Fri Oct  7 14:15:55 2005
+++ src/map.c	Sun Dec  4 20:03:08 2005
@@ -220,7 +220,7 @@
 }
 
 int   mapIn     (MAP *map, const void *key) {
-  return (mapGet(map, key) != NULL);
+  return (mapGetEntry(map, key) != NULL);
 }
 
 int   mapSize   (MAP *map) {
diff -ruN ../nakedmudv3.0/src/movement.c src/movement.c
--- ../nakedmudv3.0/src/movement.c	Fri Oct  7 14:15:55 2005
+++ src/movement.c	Sun Dec  4 20:03:08 2005
@@ -100,7 +100,7 @@
     look_at_room(ch, charGetRoom(ch));
 
     // now try all of our entrance hooks
-    hookRun("enter", ch, to, NULL);
+    hookRun("enter", ch, to);
 
     return exit;
   }
diff -ruN ../nakedmudv3.0/src/mud.h src/mud.h
--- ../nakedmudv3.0/src/mud.h	Fri Oct  7 14:15:55 2005
+++ src/mud.h	Sun Dec  4 20:03:08 2005
@@ -118,7 +118,7 @@
 #define EXE_FILE           "../src/NakedMud"      /* the name of the mud binary         */
 #define DEFAULT_PORT       4000                   /* the default port we run on */
 #define SCREEN_WIDTH       80                     // the width of a term screen
-#define PARA_INDENT        3                      // num of spaces to start para
+#define PARA_INDENT        0                      // num of spaces to start para
 
 /* Thread States */
 #define TSTATE_LOOKUP          0  /* Socket is in host_lookup        */
diff -ruN ../nakedmudv3.0/src/numbers.c src/numbers.c
--- ../nakedmudv3.0/src/numbers.c	Fri Oct  7 14:15:55 2005
+++ src/numbers.c	Sun Dec  4 20:03:08 2005
@@ -33,6 +33,10 @@
   return integer->val;
 }
 
+void integerSetVal(INTEGER *integer, int val) {
+  integer->val = val;
+}
+
 int integerCmp(INTEGER *int1, INTEGER *int2) {
   if(int1->val == int2->val)
     return 0;
@@ -65,6 +69,10 @@
   return dbl->val;
 }
 
+void doubleSetVal(DOUBLE *dbl, double val) {
+  dbl->val = val;
+}
+
 int doubleCmp(DOUBLE *dbl1, DOUBLE *dbl2) {
   if(dbl1->val == dbl2->val)
     return 0;
@@ -97,10 +105,50 @@
   return lng->val;
 }
 
+void longSetVal(LONG *lng, long val) {
+  lng->val = val;
+}
+
 int longCmp(LONG *lng1, LONG *lng2) {
   if(lng1->val == lng2->val)
     return 0;
   else if(lng1->val > lng2->val)
+    return 1;
+  else
+    return -1;
+}
+
+
+
+//*****************************************************************************
+// booleans
+//*****************************************************************************
+struct boolean_struct {
+  bool val;
+};
+
+BOOLEAN *newBoolean(bool val) {
+  BOOLEAN *bl = malloc(sizeof(BOOLEAN));
+  bl->val  = val;
+  return bl;
+}
+
+void deleteBoolean(BOOLEAN *bl) {
+  free(bl);
+}
+
+bool booleanGetVal(BOOLEAN *bl) {
+  return bl->val;
+}
+
+void booleanSetVal(BOOLEAN *bl, bool val) {
+  bl->val = val;
+}
+
+int booleanCmp(BOOLEAN *bl1, BOOLEAN *bl2) {
+  if(bl1->val == bl2->val)
+    return 0;
+  else if(bl1->val > bl2->val)
     return 1;
   else
     return -1;
diff -ruN ../nakedmudv3.0/src/numbers.h src/numbers.h
--- ../nakedmudv3.0/src/numbers.h	Fri Oct  7 14:15:55 2005
+++ src/numbers.h	Sun Dec  4 20:03:08 2005
@@ -12,20 +12,30 @@
 typedef struct int_struct      INTEGER;
 typedef struct double_struct    DOUBLE;
 typedef struct long_struct        LONG;
+typedef struct boolean_struct  BOOLEAN;
 
 INTEGER *newInteger(int val);
 void  deleteInteger(INTEGER *integer);
 int   integerGetVal(INTEGER *integer);
+void  integerSetVal(INTEGER *integer, int val);
 int      integerCmp(INTEGER *int1, INTEGER *int2);
 
 DOUBLE   *newDouble(double val);
 void   deleteDouble(DOUBLE *dbl);
 double doubleGetVal(DOUBLE *dbl);
+void   doubleSetVal(DOUBLE *dbl, double val);
 int       doubleCmp(DOUBLE *dbl1, DOUBLE *dbl2);
 
 LONG       *newLong(long val);
 void     deleteLong(LONG *lng);
 long     longGetVal(LONG *lng);
+void     longSetVal(LONG *lng, long val);
 int         longCmp(LONG *lng1, LONG *lng2);
+
+BOOLEAN *newBoolean(bool val);
+void  deleteBoolean(BOOLEAN *bl);
+bool  booleanGetVal(BOOLEAN *bl);
+void  booleanSetVal(BOOLEAN *bl, bool val);
+int      booleanCmp(BOOLEAN *bl1, BOOLEAN *bl2);
 
 #endif // NUMBERS_H
diff -ruN ../nakedmudv3.0/src/object.c src/object.c
--- ../nakedmudv3.0/src/object.c	Fri Oct  7 14:15:55 2005
+++ src/object.c	Sun Dec  4 20:03:08 2005
@@ -313,7 +313,7 @@
 
 void objSetPrototypes(OBJ_DATA *obj, const char *prototypes) {
   if(obj->prototypes) free(obj->prototypes);
-  obj->prototypes = strdupsafe(obj->prototypes);
+  obj->prototypes = strdupsafe(prototypes);
 }
 
 void objAddPrototype(OBJ_DATA *obj, const char *prototype) {
diff -ruN ../nakedmudv3.0/src/olc2/medit.c src/olc2/medit.c
--- ../nakedmudv3.0/src/olc2/medit.c	Fri Oct  7 14:15:55 2005
+++ src/olc2/medit.c	Sun Dec  4 20:03:07 2005
@@ -146,6 +146,8 @@
       while(*lptr != '\"') lptr++; lptr++;
       lptr[strlen(lptr)-1] = '\0'; // kill the ending "
       charSetDesc(ch, lptr);
+      // replace our \"s with "
+      bufferReplace(charGetDescBuffer(ch), "\\\"", "\"", TRUE);
       bufferFormat(charGetDescBuffer(ch), SCREEN_WIDTH, PARA_INDENT);
     }
     else if(!strncmp(lptr, "me.keywords", 11)) {
@@ -175,8 +177,9 @@
     }
     else if(!strcmp(lptr, "### begin extra code")) {
       code = strcpyto(line, code, '\n');
-      while(*line && strcmp(line, "### end extra code") != 0) {
+      while(strcmp(line, "### end extra code") != 0) {
 	bprintf(charOLCGetExtraCode(data), "%s\n", line);
+	if(!*code) break;
 	code = strcpyto(line, code, '\n');
       }
     }
@@ -218,6 +221,7 @@
     BUFFER *desc_copy = bufferCopy(charGetDescBuffer(ch));
     bufferReplace(desc_copy, "\n", " ", TRUE);
     bufferReplace(desc_copy, "\r", "",  TRUE);
+    bufferReplace(desc_copy, "\"", "\\\"", TRUE);
     bprintf(buf, "me.desc     = me.desc + \" \" + \"%s\"\n", 
 	    bufferString(desc_copy));
     deleteBuffer(desc_copy);
diff -ruN ../nakedmudv3.0/src/olc2/oedit.c src/olc2/oedit.c
--- ../nakedmudv3.0/src/olc2/oedit.c	Fri Oct  7 14:15:55 2005
+++ src/olc2/oedit.c	Sun Dec  4 20:03:07 2005
@@ -151,6 +151,8 @@
       while(*lptr != '\"') lptr++; lptr++;
       lptr[strlen(lptr)-1] = '\0'; // kill the ending "
       objSetDesc(obj, lptr);
+      // replace our \"s with "
+      bufferReplace(objGetDescBuffer(obj), "\\\"", "\"", TRUE);
       bufferFormat(objGetDescBuffer(obj), SCREEN_WIDTH, PARA_INDENT);
     }
     else if(!strncmp(lptr, "me.keywords", 11)) {
@@ -211,8 +213,9 @@
     }
     else if(!strcmp(lptr, "### begin extra code")) {
       code = strcpyto(line, code, '\n');
-      while(*line && strcmp(line, "### end extra code") != 0) {
+      while(strcmp(line, "### end extra code") != 0) {
 	bprintf(objOLCGetExtraCode(data), "%s\n", line);
+	if(!*code) break;
 	code = strcpyto(line, code, '\n');
       }
     }
@@ -252,6 +255,7 @@
     BUFFER *desc_copy = bufferCopy(objGetDescBuffer(obj));
     bufferReplace(desc_copy, "\n", " ", TRUE);
     bufferReplace(desc_copy, "\r", "",  TRUE);
+    bufferReplace(desc_copy, "\"", "\\\"", TRUE);
     bprintf(buf, "me.desc     = me.desc + \" \" + \"%s\"\n", 
 	    bufferString(desc_copy));
     deleteBuffer(desc_copy);
diff -ruN ../nakedmudv3.0/src/olc2/redit.c src/olc2/redit.c
--- ../nakedmudv3.0/src/olc2/redit.c	Fri Oct  7 14:15:55 2005
+++ src/olc2/redit.c	Sun Dec  4 20:03:07 2005
@@ -92,6 +92,27 @@
 
 
 //*****************************************************************************
+// utility functions
+//*****************************************************************************
+
+//
+// reload a room. used whenever a room is edited and saved
+void reload_room(const char *key) {
+  if(worldRoomLoaded(gameworld, key)) {
+    PROTO_DATA   *proto = worldGetType(gameworld, "rproto", key);
+    ROOM_DATA *old_room = worldGetRoom(gameworld, key);
+    ROOM_DATA *new_room = protoRoomRun(proto);
+    if(new_room != NULL) {
+      do_mass_transfer(old_room, new_room, TRUE, TRUE, TRUE);
+      extract_room(old_room);
+      worldPutRoom(gameworld, key, new_room);
+    }
+  }
+}
+
+
+
+//*****************************************************************************
 // functions for printing room reset data
 //*****************************************************************************
 const char *write_reset_arg(int type, const char *arg, const char *locale) {
@@ -480,7 +501,7 @@
 		 "{c%s\r\n"
 		 "{g6) Exits to    : {c%s\r\n"
 		 "{g8) Key         : {c%s\r\n"
-		 "{g7) Closable    : {y[{c%6s{y]\r\n"
+		 "{g7) Closable    : {y[{c%6s{y]%s\r\n"
 		 "{g9) Pick diff   : {y[{c%6d{y]\r\n"
 		 "{g0) Spot diff   : {y[{c%6d{y]\r\n"
 		 "{gO) Opposite dir: {c%s{n\r\n",
@@ -492,6 +513,7 @@
 		 exitGetTo(exit),
 		 exitGetKey(exit),
 		 (exitIsClosable(exit) ? "Yes" : "No" ),
+		 (exitIsClosable(exit) && (!*exitGetName(exit) || !*exitGetKeywords(exit)) ? " {r* exit also needs name and keywords{n" : ""),
 		 exitGetPickLev(exit),
 		 exitGetHidden(exit),
 		 (*exitGetOpposite(exit) ? exitGetOpposite(exit) : "<DEFAULT>")
@@ -708,8 +730,10 @@
     else if(!strncmp(lptr, "exit.desc", 9)) {
       while(*lptr != '\"') lptr++;
       lptr++;                                  // kill the leading "
-      lptr[next_letter_in(lptr, '\"')] = '\0'; // kill the ending "
+      lptr[strlen(lptr) - 1] = '\0';           // kill the ending "
       exitSetDesc(exit, lptr);
+      // replace our \"s with "
+      bufferReplace(exitGetDescBuffer(exit), "\\\"", "\"", TRUE);
       bufferFormat(exitGetDescBuffer(exit), SCREEN_WIDTH, PARA_INDENT);
     }
     else if(!strncmp(lptr, "exit.pick_diff", 14)) {
@@ -753,10 +777,12 @@
       while(*lptr != '\"') lptr++; lptr++;
       lptr[strlen(lptr)-1] = '\0'; // kill the ending "
       roomSetDesc(room, lptr);
+      // replace our \"s with "
+      bufferReplace(roomGetDescBuffer(room), "\\\"", "\"", TRUE);
       bufferFormat(roomGetDescBuffer(room), SCREEN_WIDTH, PARA_INDENT);
     }
 #ifdef MODULE_TIME
-    else if(!strncmp(lptr, "me.night_desc",  13)) {
+    else if(!strncmp(lptr, "me.ndesc",  13)) {
       // we have three "'s to skip by, because this lptr will take the form:
       // me.desc = me.desc + " " + "..."
       while(*lptr != '\"') lptr++; lptr++;
@@ -764,6 +790,8 @@
       while(*lptr != '\"') lptr++; lptr++;
       lptr[strlen(lptr)-1] = '\0'; // kill the ending "
       roomSetDesc(room, lptr);
+      // replace our \"s with "
+      bufferReplace(roomGetNightDescBuffer(room), "\\\"", "\"", TRUE);
       bufferFormat(roomGetNightDescBuffer(room), SCREEN_WIDTH, PARA_INDENT);
     }
 #endif
@@ -780,8 +808,11 @@
       lptr[next_letter_in(lptr, '\"')] = '\0';             // kill the ending "
       while(*desc_start != '\"') desc_start++;
       desc_start++;                                        // kill start and end
-      desc_start[next_letter_in(desc_start, '\"')] = '\0'; // "s for desc too
-      edescSetPut(roomGetEdescs(room), newEdesc(lptr, desc_start));
+      desc_start[strlen(desc_start)-2] = '\0';             // "s for desc too
+      EDESC_DATA *edesc = newEdesc(lptr, desc_start);
+      // replace our \"s with "
+      bufferReplace(edescGetDescBuffer(edesc), "\\\"", "\"", TRUE);
+      edescSetPut(roomGetEdescs(room), edesc);
     }
     else if(!strncmp(lptr, "me.attach(\"", 11)) {
       char trigname[SMALL_BUFFER];
@@ -820,10 +851,11 @@
       deleteBuffer(ex_buf);
     }
 
-    else if(!strcmp(lptr, "\n### begin extra code")) {
+    else if(!strcmp(lptr, "### begin extra code")) {
       code = strcpyto(line, code, '\n');
-      while(*line && strcmp(line, "### end extra code") != 0) {
+      while(strcmp(line, "### end extra code") != 0) {
 	bprintf(roomOLCGetExtraCode(data), "%s\n", line);
+	if(!*code) break;
 	code = strcpyto(line, code, '\n');
       }
     }
@@ -850,6 +882,7 @@
     BUFFER *desc_copy = bufferCopy(exitGetDescBuffer(exit));
     bufferReplace(desc_copy, "\n", " ", TRUE);
     bufferReplace(desc_copy, "\r", "",  TRUE);
+    bufferReplace(desc_copy, "\"", "\\\"", TRUE);
     bprintf(buf, "exit.desc       = \"%s\"\n", bufferString(desc_copy));
     deleteBuffer(desc_copy);
   }
@@ -885,6 +918,7 @@
     BUFFER *desc_copy = bufferCopy(roomGetDescBuffer(room));
     bufferReplace(desc_copy, "\n", " ", TRUE);
     bufferReplace(desc_copy, "\r", "",  TRUE);
+    bufferReplace(desc_copy, "\"", "\\\"", TRUE);
     bprintf(buf, "me.desc       = me.desc + \" \" + \"%s\"\n", 
 	    bufferString(desc_copy));
     deleteBuffer(desc_copy);
@@ -892,9 +926,10 @@
 #ifdef MODULE_TIME
   if(*roomGetNightDesc(room)) {
     BUFFER *desc_copy = bufferCopy(roomGetNightDescBuffer(room));
-    bufferReplace(desc_copy, "\n", " ", TRUE);
-    bufferReplace(desc_copy, "\r", "",  TRUE);
-    bprintf(buf, "me.night_desc = me.night_desc + \" \" + \"%s\"\n", 
+    bufferReplace(desc_copy, "\n", " ",    TRUE);
+    bufferReplace(desc_copy, "\r", "",     TRUE);
+    bufferReplace(desc_copy, "\"", "\\\"", TRUE);
+    bprintf(buf, "me.ndesc = me.ndesc + \" \" + \"%s\"\n", 
 	    bufferString(desc_copy));
     deleteBuffer(desc_copy);
   }
@@ -910,6 +945,7 @@
       BUFFER *desc_copy = bufferCopy(edescGetDescBuffer(edesc));
       bufferReplace(desc_copy, "\n", " ", TRUE);
       bufferReplace(desc_copy, "\r", "",  TRUE);
+      bufferReplace(desc_copy, "\"", "\\\"", TRUE);
       bprintf(buf, "me.edesc(\"%s\", \"%s\")\n", 
 	      edescGetKeywords(edesc), bufferString(desc_copy));
       deleteBuffer(desc_copy);
@@ -1239,6 +1275,9 @@
   worldSaveType(gameworld, "rproto", roomOLCGetKey(data));
   worldSaveType(gameworld, "reset",  roomOLCGetKey(data));
   zoneSave(zone);
+
+  // force-reset our room
+  reload_room(roomOLCGetKey(data));
 }
 
 
diff -ruN ../nakedmudv3.0/src/parse.c src/parse.c
--- ../nakedmudv3.0/src/parse.c	Fri Oct  7 14:15:55 2005
+++ src/parse.c	Sun Dec  4 20:03:08 2005
@@ -884,18 +884,28 @@
     break;
 
     // parse out a single word
-  case PARSE_TOKEN_WORD:
+  case PARSE_TOKEN_WORD: {
     var = newParseVar(PARSE_VAR_POINTER);
-    var->ptr_val = arg;
+    var->ptr_val    = arg;
+    bool multi_word = FALSE;
+
+    // are we using quotation marks to specify multiple words?
+    if(*arg == '\"') {
+      multi_word = TRUE;
+      arg++;
+      var->ptr_val = arg;
+    }
+
     // go through arg to the next space, and delimit the word
-    for(;*arg != '\0'; arg++) {
-      if(isspace(*arg)) {
+    for(; *arg != '\0'; arg++) {
+      if((multi_word && *arg == '\"') || (!multi_word && isspace(*arg))) {
 	*arg = '\0';
 	arg++;
 	break;
       }
     }
     break;
+  }
 
     // copies whatever is left
   case PARSE_TOKEN_STRING:
diff -ruN ../nakedmudv3.0/src/prototype.c src/prototype.c
--- ../nakedmudv3.0/src/prototype.c	Fri Oct  7 14:15:55 2005
+++ src/prototype.c	Sun Dec  4 20:03:08 2005
@@ -24,6 +24,7 @@
 // mandatory modules
 //*****************************************************************************
 #include "scripts/scripts.h"
+#include "scripts/pyplugs.h"
 #include "scripts/pychar.h"
 #include "scripts/pyroom.h"
 #include "scripts/pyobj.h"
@@ -38,6 +39,7 @@
   char   *parents;
   bool   abstract;
   BUFFER  *script;
+  PyObject  *code;
 };
 
 
@@ -51,6 +53,7 @@
   data->parents  = strdup("");
   data->abstract = TRUE;
   data->script   = newBuffer(1);
+  data->code     = NULL;
   return data;
 }
 
@@ -58,6 +61,7 @@
   if(data->key)     free(data->key);
   if(data->parents) free(data->parents);
   if(data->script)  deleteBuffer(data->script);
+  Py_XDECREF(data->code);
   free(data);
 }
 
@@ -66,6 +70,9 @@
   protoSetParents(to,  protoGetParents(from));
   protoSetScript(to,   protoGetScript(from));
   protoSetAbstract(to, protoIsAbstract(from));
+  Py_XDECREF(to->code);
+  Py_XINCREF(from->code);
+  to->code = from->code;
 }
 
 PROTO_DATA *protoCopy(PROTO_DATA *data) {
@@ -103,6 +110,8 @@
 void   protoSetScript(PROTO_DATA *data, const char *script) {
   bufferClear(data->script);
   bufferCat(data->script, script);
+  Py_XDECREF(data->code);
+  data->code = NULL;
 }
 
 void protoSetAbstract(PROTO_DATA *data, bool abstract) {
@@ -131,37 +140,44 @@
 
 bool protoRun(PROTO_DATA *proto, const char *type, void *pynewfunc, 
 	      void *protoaddfunc, void *protoclassfunc, void *me) {
-  // parse all of our parents
-  int i, num_parents = 0;
-  char     **parents = parse_keywords(proto->parents, &num_parents);
-  bool    parents_ok = TRUE;
-  for(i = 0; i < num_parents && parents_ok; i++) {
+  // parse and run all of our parents
+  LIST           *parents = parse_keywords(proto->parents);
+  LIST_ITERATOR *parent_i = newListIterator(parents);
+  char        *one_parent = NULL;
+  bool         parents_ok = TRUE;
+
+  // try to run each parent
+  ITERATE_LIST(one_parent, parent_i) {
     PROTO_DATA *parent = NULL;
     // does our parent have a locale? If so, find it. If not, use ours
-    int separator_pos = next_letter_in(parents[i], '@');
+    int separator_pos = next_letter_in(one_parent, '@');
     if(separator_pos == -1)
       parent = worldGetType(gameworld, type, 
-			    get_fullkey(parents[i],get_key_locale(proto->key)));
+			    get_fullkey(one_parent,get_key_locale(proto->key)));
     else
-      parent = worldGetType(gameworld, type, parents[i]);
-    if(parent == NULL || !protoRun(parent, type, pynewfunc, protoaddfunc, 
-				   protoclassfunc, me))
+      parent = worldGetType(gameworld, type, one_parent);
+    
+    if(parent == NULL) {
+      log_string("ERROR: could not find parent %s for %s %s.", one_parent,
+		 type, protoGetKey(proto));
       parents_ok = FALSE;
-    free(parents[i]);
-  }
+    }
+    else if(!protoRun(parent, type, pynewfunc, protoaddfunc, protoclassfunc,me))
+      parents_ok = FALSE;
+
+    // if we had a problem running the proto, report it
+    if(parents_ok == FALSE)
+      break;
+  } deleteListIterator(parent_i);
 
-  // finish cleaning up our parent keys
-  for(; i < num_parents; i++)
-    free(parents[i]);
-  free(parents);
+  // do garbage collection for our parent list
+  deleteListWith(parents, free);
 
   // did we encounter a problem w/ our parents?
   if(parents_ok == FALSE)
     return FALSE;
 
   // now, do us
-  extern PyObject *newScriptDict();
-  extern void      start_script(PyObject *dict, const char *script);
   PyObject *dict = restricted_script_dict();
   PyObject *pyme = ((PyObject *(*)(void *))pynewfunc)(me);
   if(protoaddfunc)
@@ -170,8 +186,25 @@
     ((void (*)(void *, const char *))protoclassfunc)(me, protoGetKey(proto));
 
   PyDict_SetItemString(dict, "me", pyme);
-  run_script(dict, bufferString(proto->script), 
-	     get_key_locale(protoGetKey(proto)));
+
+  // do we have our own code already, or do we need to compile from source?
+  if(proto->code == NULL) {
+    proto->code = run_script_forcode(dict, bufferString(proto->script),
+				     get_key_locale(protoGetKey(proto)));
+  }
+  // we already have a code object. Evaluate it.
+  else {
+    run_code(proto->code, dict, get_key_locale(protoGetKey(proto)));
+    
+    if(!last_script_ok()) {
+      char *tb = getPythonTraceback();
+      log_string("Prototype %s terminated with an error:\r\n%s\r\n"
+		 "\r\nTraceback is:\r\n%s\r\n", 
+		 proto->key, bufferString(proto->script), tb);
+      free(tb);
+    }
+  }
+
   Py_DECREF(dict);
   Py_DECREF(pyme);
   return last_script_ok();
@@ -182,7 +215,7 @@
     return NULL;
   CHAR_DATA *ch = newMobile();
   char_to_game(ch);
-  if(!protoRun(proto, "mproto", newPyChar, charAddPrototype, charSetClass, ch)){
+  if(!protoRun(proto, "mproto", charGetPyForm, charAddPrototype, charSetClass, ch)){
     extract_mobile(ch);
     ch = NULL;
   }
diff -ruN ../nakedmudv3.0/src/room.c src/room.c
--- ../nakedmudv3.0/src/room.c	Fri Oct  7 14:15:55 2005
+++ src/room.c	Sun Dec  4 20:03:08 2005
@@ -299,6 +299,7 @@
 //*****************************************************************************
 void roomSetExit(ROOM_DATA *room, const char *dir, EXIT_DATA *exit) {
   hashPut(room->exits, dir, exit);
+  exitSetRoom(exit, room);
 }
 
 EXIT_DATA *roomGetExit(ROOM_DATA *room, const char *dir) {
@@ -306,7 +307,9 @@
 }
 
 EXIT_DATA *roomRemoveExit(ROOM_DATA *room, const char *dir) {
-  return hashRemove(room->exits, dir);
+  EXIT_DATA *exit = hashRemove(room->exits, dir);
+  if(exit != NULL) exitSetRoom(exit, NULL);
+  return exit;
 }
 
 const char *roomGetExitDir(ROOM_DATA *room, EXIT_DATA *exit) {
diff -ruN ../nakedmudv3.0/src/room_reset.c src/room_reset.c
--- ../nakedmudv3.0/src/room_reset.c	Fri Oct  7 14:15:55 2005
+++ src/room_reset.c	Sun Dec  4 20:03:08 2005
@@ -32,6 +32,7 @@
 #include "items/items.h"
 #include "items/container.h"
 #include "items/furniture.h"
+#include "items/worn.h"
 
 
 
@@ -355,7 +356,8 @@
   // equip the mobile
   else if(initiator_type == INITIATOR_ON_MOB) {
     // see if we can equip it
-    bool equipped = try_equip(initiator, obj, NULL);
+    bool equipped = (objIsType(obj, "worn") && 
+		     try_equip(initiator, obj, NULL, wornGetPositions(obj)));
     // we failed! Extract the object
     if(!equipped) {
       extract_obj(obj);
@@ -375,7 +377,9 @@
     else if(objGetCarrier(initiator))
       obj_to_char(obj, objGetCarrier(initiator));
     else if(objGetWearer(initiator)) {
-      bool equipped = try_equip(objGetWearer(initiator), obj, NULL);
+      bool equipped = (objIsType(obj, "worn") && 
+		       try_equip(objGetWearer(initiator), obj, NULL, 
+				 wornGetPositions(obj)));
       // we failed! Extract the object
       if(!equipped) {
 	extract_obj(obj);
@@ -709,7 +713,7 @@
 
 //
 // room reset hook. Whenever a room is reset, apply all of its reset rules
-void room_reset_hook(ZONE_DATA *zone, void *none1, void *none2) {
+void room_reset_hook(ZONE_DATA *zone) {
   LIST_ITERATOR *res_i = newListIterator(zoneGetResettable(zone));
   char           *name = NULL;
   const char   *locale = zoneGetKey(zone);
diff -ruN ../nakedmudv3.0/src/save.c src/save.c
--- ../nakedmudv3.0/src/save.c	Fri Oct  7 14:15:55 2005
+++ src/save.c	Sun Dec  4 20:03:08 2005
@@ -171,9 +171,11 @@
   // and then equipped items
   list = read_list(set, "equipment");
   while( (obj_set = storage_list_next(list)) != NULL) {
-    obj = objRead(obj_set);
-    if(!try_equip(ch, obj, read_string(obj_set, "equipped")))
-      obj_to_char(obj, ch);
+    if(storage_contains(obj_set, "object")) {
+      obj = objRead(read_set(obj_set, "object"));
+      if(!try_equip(ch, obj, read_string(obj_set, "equipped"), NULL))
+	obj_to_char(obj, ch);
+    }
   }
 
   storage_close(set);
@@ -190,8 +192,9 @@
   LIST *eq_list = bodyGetAllEq(charGetBody(ch));
   OBJ_DATA *obj = NULL;
   while((obj = listPop(eq_list)) != NULL) {
-    STORAGE_SET *eq_set = objStore(obj);
-    store_string(set, "equipped", bodyEquippedWhere(charGetBody(ch), obj));
+    STORAGE_SET *eq_set = new_storage_set();
+    store_string(eq_set, "equipped", bodyEquippedWhere(charGetBody(ch), obj));
+    store_set   (eq_set, "object",   objStore(obj));
     storage_list_put(list, eq_set);
   }
   deleteList(eq_list);
diff -ruN ../nakedmudv3.0/src/scripts/pyauxiliary.c src/scripts/pyauxiliary.c
--- ../nakedmudv3.0/src/scripts/pyauxiliary.c	Fri Oct  7 14:15:55 2005
+++ src/scripts/pyauxiliary.c	Sun Dec  4 20:03:07 2005
@@ -85,9 +85,11 @@
     return NULL;
   else {
     // build our arguments and keywords
+    PyObject  *pystore = newPyStorageSet(set);
     PyObject     *args = Py_BuildValue("(O)", newPyStorageSet(set));
     PyObject *instance = PyInstance_New(proto, args, NULL);
     Py_DECREF(args);
+    Py_DECREF(pystore);
     return instance;
   }
 }
